/*
 * time.c
 *
 * Christophe Lucas <clucas@rotomalug.org>
 * This file is under GPL v2 terms
 * 
 */

#include <video/bochs.h>

unsigned long read_tsc()
{
	unsigned long tsc_high = 0 ;
	unsigned long tsc_low = 0;
	unsigned long tsc = 0 ;
	asm volatile
	(
	 	"rdtsc		\n\
		movl %%edx, %0	\n\
		movl %%eax, %1"
	: "=m" (tsc_high), "=m" (tsc_low)
	:
	: "memory", "eax", "edx"
	);
	
	bochs_printf("%s : %s() : tsc_high = %d -- tsc_low = %d\n", __FILE__, __FUNCTION__, tsc_high, tsc_low);
	tsc = (tsc_high<<16) + tsc_low;
	return tsc;
}
